import { TransactionGenerator } from "@fern-api/transaction-generator";
import { v4 as uuidv4 } from "uuid";
import { TransactionHandler } from "../../TransactionHandler";
import { Mock } from "./Mock";
import { MockPackage } from "./MockPackage";
export class MockApi extends Mock {
    definition;
    transactionHandler;
    constructor(name = "Mock API") {
        super();
        this.definition = {
            apiId: uuidv4(),
            apiName: name,
            rootPackages: [],
            packages: {},
            endpoints: {},
            types: {},
            errors: {},
        };
        this.transactionHandler = new TransactionHandler(this.definition);
    }
    addPackage(name) {
        const package_ = new MockPackage({
            name,
            applyTransaction: this.applyTransaction.bind(this),
        });
        this.transactionHandler.applyTransaction(this.definition, TransactionGenerator.createPackage({
            packageId: package_.packageId,
            packageName: package_.packageName,
        }));
        return package_;
    }
    applyTransaction(transaction) {
        return this.transactionHandler.applyTransaction(this.definition, transaction);
    }
}
