import { AbstractCreateTransactionHander } from "../AbstractCreateTransactionHander";
export class CreateErrorTransactionHandler extends AbstractCreateTransactionHander {
    addToDefinition(transaction) {
        this.definition.errors[transaction.errorId] = {
            errorId: transaction.errorId,
            errorName: transaction.errorName,
        };
    }
    addToParent(transaction) {
        const parent = this.getPackageOrThrow(transaction.parent);
        parent.errors.push(transaction.errorId);
    }
    addToGraph(transaction) {
        this.graph.createError(transaction.errorId, { parent: transaction.parent });
    }
}
