import { AbstractTransactionHandler } from "../AbstractTransactionHandler";
export class ReorderPackagesTransactionHandler extends AbstractTransactionHandler {
    applyTransaction(transaction) {
        const package_ = this.getPackageOrThrow(transaction.packageId);
        if (package_.packages.length !== transaction.newOrder.length) {
            throw new Error(`Cannot re-order packages in package ${transaction.packageId} because new order has length ${transaction.newOrder.length} and existing packages have length ${package_.packages.length}`);
        }
        const newOrderSet = new Set(transaction.newOrder);
        if (newOrderSet.size < transaction.newOrder.length) {
            throw new Error(`Cannot re-order packages in package ${transaction.packageId} because new order contains duplicates`);
        }
        package_.packages = transaction.newOrder.map((packageId) => this.getPackageOrThrow(packageId).packageId);
    }
}
